package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo   {
  @JsonProperty("totalRows")
  private Long totalRows;

  @JsonProperty("currentPage")
  private Integer currentPage;

  @JsonProperty("currentSize")
  private Integer currentSize;

  @JsonProperty("data")
  @Valid
  private List<QueryUrlFilteringOpenApiVo> data = null;

  @JsonProperty("supportKeyword")
  private Boolean supportKeyword;

  @JsonProperty("supportCategory")
  private Boolean supportCategory;

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo totalRows(Long totalRows) {
    this.totalRows = totalRows;
    return this;
  }

  /**
   * Total rows of all items.
   * @return totalRows
  */
  @ApiModelProperty(value = "Total rows of all items.")


  public Long getTotalRows() {
    return totalRows;
  }

  public void setTotalRows(Long totalRows) {
    this.totalRows = totalRows;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo currentPage(Integer currentPage) {
    this.currentPage = currentPage;
    return this;
  }

  /**
   * Current page number.
   * @return currentPage
  */
  @ApiModelProperty(value = "Current page number.")


  public Integer getCurrentPage() {
    return currentPage;
  }

  public void setCurrentPage(Integer currentPage) {
    this.currentPage = currentPage;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo currentSize(Integer currentSize) {
    this.currentSize = currentSize;
    return this;
  }

  /**
   * Number of entries per page.
   * @return currentSize
  */
  @ApiModelProperty(value = "Number of entries per page.")


  public Integer getCurrentSize() {
    return currentSize;
  }

  public void setCurrentSize(Integer currentSize) {
    this.currentSize = currentSize;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo data(List<QueryUrlFilteringOpenApiVo> data) {
    this.data = data;
    return this;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo addDataItem(QueryUrlFilteringOpenApiVo dataItem) {
    if (this.data == null) {
      this.data = new ArrayList<>();
    }
    this.data.add(dataItem);
    return this;
  }

  /**
   * Get data
   * @return data
  */
  @ApiModelProperty(value = "")

  @Valid

  public List<QueryUrlFilteringOpenApiVo> getData() {
    return data;
  }

  public void setData(List<QueryUrlFilteringOpenApiVo> data) {
    this.data = data;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo supportKeyword(Boolean supportKeyword) {
    this.supportKeyword = supportKeyword;
    return this;
  }

  /**
   * Whether keyword is supported of the URL filtering.
   * @return supportKeyword
  */
  @ApiModelProperty(value = "Whether keyword is supported of the URL filtering.")


  public Boolean getSupportKeyword() {
    return supportKeyword;
  }

  public void setSupportKeyword(Boolean supportKeyword) {
    this.supportKeyword = supportKeyword;
  }

  public UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo supportCategory(Boolean supportCategory) {
    this.supportCategory = supportCategory;
    return this;
  }

  /**
   * Whether category is supported of the URL filtering.
   * @return supportCategory
  */
  @ApiModelProperty(value = "Whether category is supported of the URL filtering.")


  public Boolean getSupportCategory() {
    return supportCategory;
  }

  public void setSupportCategory(Boolean supportCategory) {
    this.supportCategory = supportCategory;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo = (UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo) o;
    return Objects.equals(this.totalRows, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.totalRows) &&
        Objects.equals(this.currentPage, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.currentPage) &&
        Objects.equals(this.currentSize, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.currentSize) &&
        Objects.equals(this.data, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.data) &&
        Objects.equals(this.supportKeyword, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.supportKeyword) &&
        Objects.equals(this.supportCategory, urlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo.supportCategory);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalRows, currentPage, currentSize, data, supportKeyword, supportCategory);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UrlFilteringOpenApiGridVoQueryUrlFilteringOpenApiVo {\n");
    
    sb.append("    totalRows: ").append(toIndentedString(totalRows)).append("\n");
    sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
    sb.append("    currentSize: ").append(toIndentedString(currentSize)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("    supportKeyword: ").append(toIndentedString(supportKeyword)).append("\n");
    sb.append("    supportCategory: ").append(toIndentedString(supportCategory)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

